/*
 * $Id: globals.h,v 1.1 2000/01/29 20:44:41 kline Exp kline $
 *
 *   List of external header files; and extern declaration of global variables.
 */

#ifndef _GLOBALS_H_
#define _GLOBALS_H_

#define C_PP 1  /* Here and in muuztypes.h (also) */

#ifdef C_PP
extern "C"
{
#endif

#include <stdio.h>
#include <X11/Xlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <signal.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <strings.h>
#include <sys/stat.h>
#include <sys/time.h>
#include <sys/wait.h>
#include <unistd.h>
#include <X11/Intrinsic.h>
#include <X11/StringDefs.h>
#include <X11/Shell.h>
#include <X11/Core.h>
#include <X11/X.h>
#include <X11/Xatom.h>
#include <X11/Xaw/AsciiText.h>
#include <X11/Xaw/Box.h>
#include <X11/Xaw/Command.h>
#include <X11/Xaw/Dialog.h>
#include <X11/Xaw/Form.h>
#include <X11/Xaw/MenuButton.h>
#include <X11/Xaw/SimpleMenu.h>
#include <X11/Xaw/SmeBSB.h>
#include <X11/Xaw/SmeLine.h>
#include <X11/Xaw/Toggle.h>
#include <X11/Xos.h>
#include <X11/Xutil.h>
#include <X11/keysymdef.h>
#include  <X11/Intrinsic.h>
#include  <X11/Xaw/AsciiText.h>
#include  <X11/Xaw/Box.h>
#include  <X11/Xaw/Command.h>
#include  <X11/Xaw/MenuButton.h>
#include  <X11/Xaw/SimpleMenu.h>
#include  <X11/Xaw/SmeBSB.h>
#include  <X11/Xaw/SmeLine.h>
#include "/usr/X11R6/include/X11/Xaw3d/ThreeD.h"

#ifdef C_PP
}
#endif

/*
 *   The majority of the non-muuz-typedefs external declarations are here.
 */
extern XtAppContext  app;
extern Widget        top;  /* toplevel widget of muuz */

/***  displayWidget Font variables ***/
extern XFontStruct     *selectionFont, *programFont;
/**extern XFontStruct *init_font(Display *display, const char *fontName);
**/

extern XFontStruct *avFont, *colorsFont, *hertzFont, *pitchFont,
				  *actionFont, *volumeFont;
extern XFontStruct *avDisplayFont, *colorsDisplayFont, *hertzDisplayFont,
  *pitchDisplayFont, *sspDisplayFont, *volumeDisplayFont;

extern Widget  DownArrow, UpArrow;
extern Widget selectionup_button, selectiondown_button, progup_button,
	progdown_button;
extern Widget  form, menuform, formbox0, formbox1, formbox2, formflash,
        formtopic, formprogram;



extern int HzArray[];

extern Widget labelDesc, displayColors, displayHertz, displayPitch, 
	displayPrep, displayProg, displayAction, displayVolume, displayAv;
extern Widget labelProgram, labelProgdescription, labelSelection;

/* the strings to use in the button, depending on its mode */
extern char *avDisplayLabels[] ;
extern char *colorsDisplayLabels[];
extern char *prepTopicsButtonLabel[] ;
extern char *prepDownButtonLabel[] ;
extern char *prepUpButtonLabel[] ;
extern char *progDownButtonLabel[] ;
extern char *progUpButtonLabel[] ;
extern char *quitDisplayLabel ;
extern char *volumeUpButtonLabel[] ;
extern char *volumeDownButtonLabel[] ;
extern char *hertzDisplayLabels[] ;
extern char *pitchDisplayLabels[] ;
extern char *sspDisplayLabels[] ;
extern char  *volumeDisplayLabel[] ;
extern Display *display;


/*
 * prep-programmed display title strings[]
 */
extern char *c_cr[];
extern char *c_lr[];
extern char *c_rx[];
extern char *c_md[];
extern char *c_sl[];
extern char *c_en[];
extern char *c_fu[];

/*
 * labelDescription for each program
 */

extern char *label_cr[];
extern char *label_lr[];
extern char *label_rx[];

extern unsigned long global_flash_color;


extern Widget av_button, colors_button, pitch_button, quit_button, ssp_button;
/*
extern Widget formav, formcolors, formhertz, formpitch, formAction, formvolume;
*/
extern Widget formav, formcolors, formhertz, formAction;
extern Widget avdown_button, avup_button, colorsup_button, 
	colorsdown_button, sspdown_button, sspup_button;
extern Widget hertzup_button, hertzdown_button;
extern Widget labelAv, labelColors, labelHertz, labelPitch, 
		labelAction, labelVolume;
extern Widget pitchup_button, pitchdown_button;
extern Widget volumeup_button, volumedown_button;
extern XFontStruct *avFont, *colorsFont, *hertzFont, *pitchFont, 
				*volumeFont;
extern Widget labelForm;

extern XColor   blue_color, exact_color, pink_color, grey_color, orange_color,
	red_color, hotpink_color, yellow_color, skyblue_color,
	slategrey_color, green_color, darkblue_color, peru_color;
extern XColor grey85_color;

extern unsigned long int black_color, white_color;

extern XFontStruct *labelFont;

extern char *blankDescLabel, *blankProgWin;
        


extern Colormap        private_cmap;

extern GC flashgc;  
extern Display  *flashdisplay;
extern Drawable flashwindow;
extern XGCValues flashes_gcv, audio_gcv;
extern unsigned long hertz;
extern XtAppContext app;

/*
 *  audio globals
 */
extern char *high_o[];
extern char *low_o[];
extern char *medium_o[];
extern char *argvector[];
extern char Argstring[];
extern int kill_id, loopflg;
extern XtIntervalId btimeout;
extern int devfd, onetime, stereo, samplerate, frag_size;
extern int Argc;
extern unsigned int millisecPerTone;





/* 
 * state conditions
 */

extern int stop, Pause, play;
extern int allmodes, allflags;
/**extern int prepstate; */

   
#endif /* !_GLOBALS_H_ */


