/*
 * $Id: select.c,v 1.1 2000/01/29 20:44:51 kline Exp kline $
 */

#include <X11/Intrinsic.h>

#include "iconmuuz.h"
#include "muuz.h"
#include "muuztypes.h"
#include "xfonts.h"

#include "misc.h"
#include "errMessage.h"
#include "main.h"
#include "callbacks.h"
#include "prepcallbacks.h"
#include "userprogram.h"
#include "copyright.h"




extern void
select_prep_or_user()
{
  Widget  selectpanel, selectprep, selectuser;
  XFontStruct *controlpanelFont,*quitFont,*preprogrammedFont,*usercreatedFont;
  Widget quit_button;

  /*
   * formbox0 buttons
   */


  //
  // partly controls the width of the 6-button panel
  //
  controlpanelFont = init_font(display, NCS12);
  if (depth > 8)
  {
  selectpanel =
    XtVaCreateManagedWidget("selectpanel", commandWidgetClass, formbox0,
			    XtNfont, controlpanelFont,
                            XtNlabel, L_CONTROLPANEL, /*"Control Panel",*/
                            XtNfromVert, NULL,
                            XtNfromHoriz, NULL,
                            XtNheight, Do.resizeH(25), // button height
                            XtNwidth, Do.resizeW(158),
			      // STABLEPANEL_COLORS
			      XtNbackground,grey85_color.pixel, 
			      XtNforeground,darkblue_color.pixel,  
			      XtNshadowWidth,  4,
                            XtNtop, XawChainTop,
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);

  }
  else
  {
  selectpanel =
    XtVaCreateManagedWidget("selectpanel", commandWidgetClass, formbox0,
	XtNfont, controlpanelFont,
	XtNlabel, L_CONTROLPANEL, /*"Control Panel",*/
	XtNfromVert, NULL,
	XtNfromHoriz, NULL,
	XtNheight, Do.resizeH(25), // button height
	XtNwidth, Do.resizeW(158),  // was 123 and 158.
	// STABLEPANEL_COLORS
	XtNbackground,grey85, 
	XtNforeground,darkblue,
	XtNshadowWidth,  4,
	XtNtop, XawChainTop,
	XtNbottom, XawChainTop,
	XtNleft, XawChainLeft,
	XtNright, XawChainLeft,
	NULL);

  }

  XtAddCallback(selectpanel, XtNcallback, selectpanel_buttonCB, NULL);




  preprogrammedFont = init_font(display, NCS12);
  if (depth > 8)
  {
  selectprep =
    XtVaCreateManagedWidget("selectprep", commandWidgetClass, formbox0,
			    XtNfont, preprogrammedFont,
                            XtNlabel, L_PREPROGRAMMED, 
                            XtNfromVert, selectpanel,
                            XtNfromHoriz, NULL,
                            XtNheight, Do.resizeH(24), // button height
                            XtNwidth, Do.resizeW(158),
			      // STABLEPANEL_COLORS
			      XtNbackground,grey85_color.pixel, 
			      XtNforeground,darkblue_color.pixel,  
			      XtNshadowWidth,  4,
                            XtNtop, XawChainTop,
			    XtNvertDistance, Do.resizeH(5),
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);
  }
  else
  {
    selectprep =
      XtVaCreateManagedWidget("selectprep", commandWidgetClass, formbox0,
			    XtNfont, preprogrammedFont,
                            XtNlabel, L_PREPROGRAMMED, 
                            XtNfromVert, selectpanel,
                            XtNfromHoriz, NULL,
                            XtNheight, Do.resizeH(24), // button height
                            XtNwidth, Do.resizeW(158),
			      // STABLEPANEL_COLORS
			      XtNbackground,grey85, 
			      XtNforeground,darkblue,
			      XtNshadowWidth,  4,
                            XtNtop, XawChainTop,
			    XtNvertDistance, Do.resizeH(5),
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);

  }


  XtAddCallback(selectprep, XtNcallback, selectprep_buttonCB, NULL);


  usercreatedFont = init_font(display, NCS12);

  if (depth > 8)
  {
  selectuser =
    XtVaCreateManagedWidget("selectuser", commandWidgetClass, formbox0,
			    XtNfont, usercreatedFont,
                            XtNlabel, L_USERCREATED,
                            XtNfromVert, selectprep,
                            XtNfromHoriz, NULL,
                            XtNheight, Do.resizeH(24), // button height
                            XtNwidth, Do.resizeW(158),
			      // STABLEPANEL_COLORS
			      XtNbackground,grey85_color.pixel, 
			      XtNforeground,darkblue_color.pixel,  
			      XtNshadowWidth,  4,
                            XtNvertDistance, Do.resizeH(5),
                            XtNtop, XawChainTop,
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);
  }
  else
  {
  selectuser =
    XtVaCreateManagedWidget("selectuser", commandWidgetClass, formbox0,
			    XtNfont, usercreatedFont,
                            XtNlabel, L_USERCREATED,
                            XtNfromVert, selectprep,
                            XtNfromHoriz, NULL,
                            XtNheight, Do.resizeH(24), // button height
                            XtNwidth, Do.resizeW(158),
			      // STABLEPANEL_COLORS
			      XtNbackground,grey85, 
			      XtNforeground,darkblue,
			      XtNshadowWidth,  4,
                            XtNvertDistance, Do.resizeH(5),
                            XtNtop, XawChainTop,
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);

  }


  XtAddCallback(selectuser, XtNcallback, selectuser_buttonCB, NULL);



  quitFont = init_font(display, NCS12);
  if (depth > 8)
  {
  quit_button =
    XtVaCreateManagedWidget("quit_button", commandWidgetClass, formbox0,
			    XtNfont,  quitFont,
                            XtNlabel, L_QUIT,
                            XtNfromVert, selectuser,
                            XtNfromHoriz, NULL,
                            XtNheight, Do.resizeH(25),
                            XtNwidth, Do.resizeW(158),
			    // STABLEPANEL_COLORS
			    XtNbackground,grey85_color.pixel,\
			    XtNforeground,darkblue_color.pixel, \
			    XtNshadowWidth,  4,

                            XtNtop, XawChainTop,
			    XtNvertDistance, Do.resizeH(5),
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);
  }
  else
  {
    quit_button =
      XtVaCreateManagedWidget("quit_button", commandWidgetClass, formbox0,
			    XtNfont,  quitFont,
                            XtNlabel, L_QUIT,
                            XtNfromVert, selectuser,
                            XtNfromHoriz, NULL,
                            XtNheight,Do.resizeH(25),
                            XtNwidth, Do.resizeW(158),  // all were 123
			    // STABLEPANEL_COLORS
			    XtNbackground,grey85,\
			    XtNforeground,darkblue, \
			    XtNshadowWidth,  4,
                            XtNtop, XawChainTop,
			    XtNvertDistance, Do.resizeH(5),
                            XtNbottom, XawChainTop,
                            XtNleft, XawChainLeft,
                            XtNright, XawChainLeft,
                            NULL);

  }


  XtAddCallback (quit_button, XtNcallback, AskConfirmCB, NULL);


}

